package com.unis.inspectionplan.client;

import java.util.List;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.HttpStatus;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectionplan.common.vo.BaseInfoVO;
import com.unis.inspectionplan.common.vo.GatherQueryVO;
import com.unis.inspectionplan.common.vo.GatherVO;
import com.unis.inspectionplan.common.vo.ReportVO;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@FeignClient(name = "inspectionplan-server")
@Component
@Api(value = "检查计划", tags = "检查计划")
public interface BaseInfoFeign {

	@ApiOperation(value = "查询基础信息列表")
    @PostMapping("/baseinfo")
    public ResponseWrapper gather(@RequestBody List<String> orgids);
	
	
	@ApiOperation(value = "查询详情")
    @PostMapping("/getbaseinfo/{orgid}")
    public ResponseWrapper gatherInfo(@PathVariable("orgid")String orgid);
	
	@ApiOperation(value = "查询详情")
    @PostMapping("/getbaseinfocha/{orgid}")
    public ResponseWrapper getbaseinfocha(@PathVariable("orgid")String orgid);
	
	
	
	@ApiOperation(value = "更新基础信息")
    @PutMapping("/getbaseinfo")
    public ResponseWrapper getbaseinfo(@RequestBody BaseInfoVO baseInfoVO);
	
	
	@ApiOperation(value = "经费落实情况")
    @PutMapping("/jfReport/{nd}")
    public ResponseWrapper jflsqk(@RequestBody List<String> orgids,@PathVariable("nd")String nd);
	
	
	
	
	@ApiOperation(value = "更新基础信息")
    @PutMapping("/zfdReport/{nd}")
    public ResponseWrapper zfdReport(@RequestBody List<String> orgids,@PathVariable("nd")String nd);
}
