package com.unis.inspectionplan.client;

import java.util.List;

import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectionplan.common.vo.GatherQueryVO;
import com.unis.inspectionplan.common.vo.GatherVO;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;

@FeignClient(name = "inspectionplan-server")
@Component
@Api(value = "检查计划", tags = "检查计划")
public interface GatherFeign {

	@ApiOperation(value = "新增/更新专项汇总")
    @PostMapping("/gather")
    public ResponseWrapper gather(@RequestBody List<GatherVO> gatherVOs);
	
	
	@ApiOperation(value = "查询详情")
    @PostMapping("/gatherInfo")
    public ResponseWrapper gatherInfo(@RequestBody GatherQueryVO gatherQueryVO);
	
	@ApiOperation(value = "退回")
	@PostMapping("/gatherInfoBack")
    public ResponseWrapper updategatherInfo(@RequestBody List<String> dwids);
}
