package com.unis.inspectionplan.client;

import java.util.List;
import java.util.Map;

import org.apache.commons.collections.CollectionUtils;
import org.springframework.cloud.openfeign.FeignClient;
import org.springframework.http.HttpStatus;
import org.springframework.http.ResponseEntity;
import org.springframework.stereotype.Component;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.PutMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RequestParam;

import com.alibaba.fastjson.JSONObject;
import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectionplan.common.vo.InspectionplanQueryVO;
import com.unis.inspectionplan.common.vo.InspectionplanVO;
import com.unis.inspectionplan.common.vo.YearPlanChartVO;
import com.unis.inspectionplan.common.vo.YearPlanVO;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiImplicitParam;
import io.swagger.annotations.ApiImplicitParams;
import io.swagger.annotations.ApiOperation;

@FeignClient(name = "inspectionplan-server")
@Component
@Api(value = "检查计划", tags = "检查计划")
public interface YearPlanFeign {

	@ApiOperation(value = "新增年度计划")
    @PostMapping("/yearplan")
    public ResponseWrapper insertyearplan(@RequestBody YearPlanVO yearPlanVO);
	
	/**
	 * 新增检查计划
	 * @return
	 */
	@ApiOperation(value = "修改检查计划")
    @PutMapping("/yearplan")
    public ResponseWrapper updateyearplan(@RequestBody YearPlanVO yearPlanVO);
	
	
	/**
     * 根据条件分页获取信息列表
     */
    @PostMapping("/yearplan/{pageNum}/{pageSize}")
    public ResponseWrapper getInspectionplanList(@RequestParam(value="jhnf",required = false) String jhnf,
                                                 @RequestParam(value="jhmc",required = false) String jhmc,
    		   @PathVariable(value = "pageNum") Integer pageNum,
			   @PathVariable(value = "pageSize") Integer pageSize);
    
    
    /**
     * 根据条件分页获取信息列表
     */
    @PostMapping("/yearplanChat")
    public ResponseWrapper yearplanChat(@RequestParam(value="jhnf",required = false) String jhnf, @RequestParam(value="jhmc",required = false) String jhmc);

    @DeleteMapping("/yearplan/{id}")
	public ResponseWrapper yearplan(@PathVariable(value="id")String id);
}
