package com.unis.inspectionplan.common.vo;

import java.util.Date;
import java.util.List;


import org.springframework.format.annotation.DateTimeFormat;

import com.fasterxml.jackson.annotation.JsonFormat;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;
@SuppressWarnings("serial")
@Getter
@Setter
@ApiModel("检查计划实体类")
public class InspectionplanVO extends BaseVO  {
	
	/**
	 * 计划编号
	 */
    @ApiModelProperty("计划id")
    private String jhId;

    /**
     * 计划名称 
     */
    @ApiModelProperty("计划名称 ")
    private String jhName;

    /**
     * 任务类型编号
     */
    @ApiModelProperty("任务类型编号")
    private String rwlxId;

    /**
     *  任务类型名称 
     */
    @ApiModelProperty(" 任务类型名称 ")
    private String rwlxmc;
    
    
    /**
	 * 检查单位id
	 */
	@ApiModelProperty("检查单位")
	private String jcdwId; 
    
    /**
     * 检查单位
     */
    @ApiModelProperty("检查单位")
    private String jcdw;

    /**
     * 被检单位类型
     */
	@ApiModelProperty("被检单位类型")
	private String bjdwlx;
	
    /**
     * 是否分配本级检查组（0、是。1、否）
     */
    @ApiModelProperty("是否分配本级检查组（0、是。1、否）")
    private Integer isBjjcz;

    /**
     * 被检单位选择方式（0、单一。1、组合）
     */
    @ApiModelProperty("被检单位选择方式（0、单一。1、组合）")
    private Integer bjdwfx;

    /**
     * 任务起始日
     */
    @ApiModelProperty("任务起始日")
	@DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date rwqsr;

    /**
     * 任务结束日
     */
    @ApiModelProperty("任务结束日")
   	@DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date rwjsr;
    
    /**检查单位
     * 
     */
    @ApiModelProperty("检查单位")
    private List<InspectionUnitVO> jcdwList;
    
    /**
     * 被检企业类型
     */
    @ApiModelProperty("被检企业类型")
    private List<TypesofInspectedUnitsVO> bjdwlxList; 
    
    /**
     * 文件
     */
    @ApiModelProperty("文件")
    private List<FileVO> file;
    
    /**
     * 检查表单
     */
    @ApiModelProperty("检查表单")
	private List<CheckformVO> jcbd;
    
    /**
     * 关联表单
     */
    @ApiModelProperty("关联表单")
	private String glbd;
    
    /**
     * 组织id
     */
    @ApiModelProperty("组织id")
    private String orgId;
    
    
    /**
     * 组织id
     */
    @ApiModelProperty("计划id")
    private String planid;
    
    /**
     * 下发人
     */
    @ApiModelProperty("下发人")
    private String xfr;
    
    /**
     * 下发时间
     */
    @ApiModelProperty("下发时间")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date xfsj;
    
    /**
     * 计划状态
     */
    @ApiModelProperty("计划状态  1、待下发。2、一下发。3、已完成。4、已过期")
    private Integer jhzt;


    /**
	 * 检查任务id
	 */
    @ApiModelProperty("检查任务id")
    private String rwId;
}