package com.unis.inspectionplan.common.vo;

import com.fasterxml.jackson.annotation.JsonFormat;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.AllArgsConstructor;
import lombok.Getter;
import lombok.NoArgsConstructor;
import lombok.Setter;

import java.io.Serializable;
import java.math.BigDecimal;
import java.util.Date;

@Getter
@Setter
@AllArgsConstructor
@NoArgsConstructor
@ApiModel("仓房垛位信息")
public class StockVO implements Serializable {

    @ApiModelProperty(value = "仓号")
    private String houseId;

    @ApiModelProperty(value = "垛位号")
    private String warehouseId;

    @ApiModelProperty(value = "等级")
    private String levels;

    @ApiModelProperty(value = "垛位名称")
    private String stockName;

    @ApiModelProperty(value = "数量(吨)")
    private BigDecimal sl;

    @ApiModelProperty(value = "包数")
    private Integer bs;

    @ApiModelProperty(value = "规格")
    private BigDecimal specifications;

    @ApiModelProperty(value = "生产日期")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private Date scrq;

    @ApiModelProperty(value = "入仓时间")
    @JsonFormat(pattern = "yyyy-MM-dd",timezone = "GMT+8")
    private Date startTime;

    @ApiModelProperty(value = "保质期")
    private Integer bzq;

    @ApiModelProperty(value = "品牌")
    private String pinp;
}