package com.unis.inspectionplan.common.vo;

import java.util.Date;
import java.util.List;


import org.springframework.format.annotation.DateTimeFormat;

import com.fasterxml.jackson.annotation.JsonFormat;

import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import lombok.Getter;
import lombok.Setter;

@Getter
@Setter
@ApiModel("年度计划实体类")
public class YearPlanVO  {
	
	/**
	 * 计划编号
	 */
    @ApiModelProperty("id")
    private String id;

    /**
     * 计划名称 
     */
    @ApiModelProperty("计划年份 ")
    private String jhnf;

    /**
     * 任务类型编号
     */
    @ApiModelProperty("计划名称")
    private String jhmc;

    /**
     *  任务类型名称 
     */
    @ApiModelProperty("计划内容 ")
    private String jhnr;
    

    /**
     * 任务起始日
     */
    @ApiModelProperty("计划开始日")
	@DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date jhkssj;

    /**
     * 任务结束日
     */
    @ApiModelProperty("计划结束日")
   	@DateTimeFormat(pattern="yyyy-MM-dd")
    @JsonFormat(shape = JsonFormat.Shape.STRING, pattern = "yyyy-MM-dd", timezone = "PRC")
    private Date jhjssj;
    
    /**检查单位
     * 
     */
    @ApiModelProperty("检查单位")
    private List<YearPlanOrgVO> jcdwList;
    
    
    /**
     * 下发人
     */
    @ApiModelProperty("下发人")
    private String zdr;
    
    /**
     * 下发时间
     */
    @ApiModelProperty("下发时间")
	@DateTimeFormat(pattern = "yyyy-MM-dd HH:mm:ss")
	@JsonFormat(pattern = "yyyy-MM-dd HH:mm:ss",timezone = "GMT+8")
    private Date zdsj;
    
    /**
     * 计划状态
     */
    @ApiModelProperty("计划状态  0、待生成。1、已生成 .2、待生成（撤回标识）")
    private String status;

    @ApiModelProperty("权限")
    private String orgid;
}