package com.unis.inspectionplan.server.controller;

import java.util.List;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.http.HttpStatus;
import org.springframework.web.bind.annotation.DeleteMapping;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.PostMapping;
import org.springframework.web.bind.annotation.RequestBody;
import org.springframework.web.bind.annotation.RestController;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectionplan.common.vo.GatherQueryVO;
import com.unis.inspectionplan.common.vo.GatherVO;
import com.unis.inspectionplan.server.service.GatherService;

import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import lombok.extern.slf4j.Slf4j;
 
@RestController
@Slf4j
@Api(value = "专项汇总", tags = "专项汇总")
public class GatherController {
	
	@Autowired
	private GatherService gatherService;
 
	/**
	 * 新增检查计划
	 * @return
	 */
	@ApiOperation(value = "新增/更新专项汇总")
    @PostMapping("/gather")
    public ResponseWrapper gather(@RequestBody List<GatherVO> gatherVOs) {
    	try {
    		int insertJcjh = gatherService.gather(gatherVOs);
    		if(insertJcjh>0){
    			if(gatherVOs!=null&&gatherVOs.size()>0&&gatherVOs.get(0).getSjzt().equals("0")) {
    				return ResponseWrapper.success(HttpStatus.OK.value(), "保存成功", gatherVOs);
    			}
    			return ResponseWrapper.success(HttpStatus.OK.value(), "提交成功", gatherVOs);
    		}
    		return ResponseWrapper.success(HttpStatus.OK.value(), "数据保存失败", insertJcjh);
		} catch (Exception e) {
			log.error(e.getMessage());
            return ResponseWrapper.error(HttpStatus.INTERNAL_SERVER_ERROR.value(), "服务异常", null);
		}
    }
	
	
	@ApiOperation(value = "查询详情")
    @PostMapping("/gatherInfo")
    public ResponseWrapper gatherInfo(@RequestBody GatherQueryVO gatherQueryVO) {
    	try {
    		GatherVO insertJcjh = gatherService.gatherInfo(gatherQueryVO);
    		return ResponseWrapper.success(HttpStatus.OK.value(), "查询数据成功", insertJcjh);
		} catch (Exception e) {
			log.error(e.getMessage());
            return ResponseWrapper.error(HttpStatus.INTERNAL_SERVER_ERROR.value(), "服务异常", null);
		}
    }
	
	
	@ApiOperation(value = "退回")
	@PostMapping("/gatherInfoBack")
    public ResponseWrapper updategatherInfo(@RequestBody List<String> dwids) {
    	try {
    		int insertJcjh = gatherService.updategatherInfo(dwids);
    		return ResponseWrapper.success(HttpStatus.OK.value(), "查询数据成功", insertJcjh);
		} catch (Exception e) {
			log.error(e.getMessage());
            return ResponseWrapper.error(HttpStatus.INTERNAL_SERVER_ERROR.value(), "服务异常", null);
		}
    }
}