package com.unis.inspectionplan.server.dao;

import java.util.List;

import com.unis.inspectionplan.common.vo.InspectionplanVO;
import org.apache.ibatis.annotations.Param;
import org.springframework.stereotype.Repository;
import org.springframework.transaction.annotation.Transactional;

import com.unis.inspectionplan.common.vo.InspectionplanQueryVO;
import com.unis.inspectionplan.server.entity.TJcjhDO;
import com.unis.inspectionplan.server.example.TJcjhExample;

import tk.mybatis.mapper.entity.Example;

@Transactional(rollbackFor = Exception.class)
@org.apache.ibatis.annotations.Mapper
@Repository
public interface TJcjhDao {
    int countByExample(TJcjhExample example);

    int deleteByExample(TJcjhExample example);

    int deleteByPrimaryKey(String id);

    int insert(TJcjhDO record);

    int insertSelective(TJcjhDO record);

    List<TJcjhDO> selectByExample(Example example);

    TJcjhDO selectByPrimaryKey(@Param("jhId")String jhId);

    int updateByExampleSelective(@Param("record") TJcjhDO record, @Param("example") TJcjhExample example);

    int updateByExample(@Param("record") TJcjhDO record, @Param("example") TJcjhExample example);

    int updateByPrimaryKeySelective(TJcjhDO record);

    int updateByPrimaryKey(TJcjhDO entity);


	String getMaxCodeById(@Param("pstr")String pstr);


	List<TJcjhDO> getList(InspectionplanQueryVO queryvo);

	/**
	 * @param rwlxbh
	 * @return 根据任务类型编号获取计划信息
	 */
	List<TJcjhDO> getJcjhList(@Param("rwlxbh") String rwlxbh);

	List<TJcjhDO> getplaceList(InspectionplanQueryVO queryvo);

	int update(@Param("jhId")String jhId);

	int updateOverDueByEntitySelective(InspectionplanVO inspectionplanVO);

	/**
	 * @Title: getPlanList
	 * @Description:方法描述:(这里用一句话描述这个方法的作用)
	 * @param @param tJcjhDO
	 * @param @return    设定文件
	 * @return List<TJcjhDO>    返回类型
	 * @throws
	*/
	List<TJcjhDO> getPlanList(TJcjhDO tJcjhDO);

	/**
	 *
	 * @Description: 获取某状态计划总数
	 * @author: 王帅
	 * @param: @return  参数
	 * @return: long    返回类型
	 */
	Long getPlanUnfinishedCount(@Param("status")Integer status);

	void updateById(@Param("jhId")String jhId);

	int backlog(@Param("id")String id);
}
