package com.unis.inspectionplan.server.domain;

import java.text.SimpleDateFormat;
import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.List;
import java.util.Map;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.LsBeanUtils;
import com.unis.common.utils.UUIDUtils;
import com.unis.inspectionplan.common.vo.BaseInfoVO;
import com.unis.inspectionplan.common.vo.FileVO;
import com.unis.inspectionplan.common.vo.GatherQueryVO;
import com.unis.inspectionplan.common.vo.GatherVO;
import com.unis.inspectionplan.common.vo.ReportVO;
import com.unis.inspectionplan.server.dao.BaseInfoDao;
import com.unis.inspectionplan.server.dao.GatherDao;
import com.unis.inspectionplan.server.dao.TFileDao;
import com.unis.inspectionplan.server.entity.TFileDO;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

@Getter
@Setter
@ToString
@Component
public class BaseInfoDomain {

	@Autowired
	private BaseInfoDao baseInfoDao;


	@Autowired
	private TFileDao fileDao;

	public  List<BaseInfoVO> gather(List<String> orgids) {
		 List<BaseInfoVO> baseInfoVOs = new ArrayList<BaseInfoVO>();
		for(String gatherVO:orgids) {
			BaseInfoVO baseInfoVO = baseInfoDao.gatherInfo(gatherVO);
			baseInfoVOs.add(baseInfoVO);
		}
		return baseInfoVOs;
	}

	public BaseInfoVO gatherInfo(String orgid) {
		BaseInfoVO baseInfoVO = baseInfoDao.gatherInfo(orgid);
		if(baseInfoVO!=null) {
			// 获取检查文件列表
			List<FileVO> voList4 = new ArrayList<FileVO>();
			List<TFileDO> doList4 = fileDao.selectBySjid(orgid);
			for (TFileDO tFileDO : doList4) {
				FileVO vo = new FileVO();
				LsBeanUtils.copyAllProperties(tFileDO, vo);
				voList4.add(vo);
			}
			baseInfoVO.setFileVOs(voList4);
		}
		return baseInfoVO;
	}



	public BaseInfoVO gatherInfoCha(String orgid) {
		BaseInfoVO baseInfoVO = baseInfoDao.gatherInfoCha(orgid);
		if(baseInfoVO!=null) {
			// 获取检查文件列表
			List<FileVO> voList4 = new ArrayList<FileVO>();
			List<TFileDO> doList4 = fileDao.selectBySjid(orgid);
			for (TFileDO tFileDO : doList4) {
				FileVO vo = new FileVO();
				LsBeanUtils.copyAllProperties(tFileDO, vo);
				voList4.add(vo);
			}
			baseInfoVO.setFileVOs(voList4);
		}
		return baseInfoVO;
	}

	public int updategatherInfo(BaseInfoVO baseInfoVO) {
		String sign= new SimpleDateFormat("yyyy-MM").format(new Date());

		baseInfoDao.delete(baseInfoVO.getOrgid(),sign);
		baseInfoVO.setNd(sign);
		baseInfoDao.create(baseInfoVO);

		fileDao.deleteByuid(baseInfoVO.getOrgid());
		// 新增TFileDO
		List<FileVO> voList4 = baseInfoVO.getFileVOs();
		if(voList4 != null&&voList4.size()>0){
			for (FileVO fileVO : voList4) {
				TFileDO tFileDO = new TFileDO();
				fileVO.setSjId(baseInfoVO.getOrgid());
				fileVO.setStatus(1);
				LsBeanUtils.copyAllProperties(fileVO, tFileDO);
				fileDao.insertSelective(tFileDO);
			}
		}


		return 1;
	}

	public List<ReportVO> jflsqk(List<String> orgids, String nd) {
		List<ReportVO> baseInfoVOs = new ArrayList<ReportVO>();
		for(String gatherVO:orgids) {
			ReportVO baseInfoVO = baseInfoDao.jflsqk(gatherVO,nd);
			if(baseInfoVO!=null) {
				if(gatherVO.equals("LS001")) {
					baseInfoVO.setXzqs(16);
				} else {
					baseInfoVO.setXzqs(1);
				}
			}
			baseInfoVOs.add(baseInfoVO);
		}
		return baseInfoVOs;
	}

	public List<ReportVO> zfdReport(List<String> orgids, String nd) {
		List<ReportVO> baseInfoVOs = new ArrayList<ReportVO>();
		for(String gatherVO:orgids) {
			ReportVO baseInfoVO = baseInfoDao.zfdReport(gatherVO,nd);
			baseInfoVOs.add(baseInfoVO);
		}
		return baseInfoVOs;
	}

	public void create() {
		List<BaseInfoVO> baseInfoVOs = baseInfoDao.getList();
		String sign= new SimpleDateFormat("yyyy-MM").format(new Date());
		for(BaseInfoVO baseInfoVO:baseInfoVOs) {
			baseInfoVO.setNd(sign);
			baseInfoDao.delete(baseInfoVO.getOrgid(),sign);
			baseInfoDao.create(baseInfoVO);
		}
	}


}
