package com.unis.inspectionplan.server.domain;

import java.util.List;
import java.util.Map;

import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.unis.common.utils.CurrentUtil;
import com.unis.common.utils.UUIDUtils;
import com.unis.inspectionplan.common.vo.GatherQueryVO;
import com.unis.inspectionplan.common.vo.GatherVO;
import com.unis.inspectionplan.server.dao.GatherDao;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

@Getter
@Setter
@ToString
@Component
public class GatherDomain {

	@Autowired
	private GatherDao gatherDao;

	public int gather(List<GatherVO> gatherVOs) {
		int x=0;
		for(GatherVO gatherVO:gatherVOs) {
			GatherVO vo = new GatherVO();
			vo.setTbnd(gatherVO.getTbnd());
			vo.setTblx(gatherVO.getTblx());
			if(StringUtils.isEmpty(gatherVO.getDwid())){
				String orgId=CurrentUtil.getOrgId();
				vo.setDwid(orgId);
				gatherVO.setDwid(orgId);
			}else{
				vo.setDwid(gatherVO.getDwid());
			}
			GatherVO vo2 = gatherDao.getGather(vo);
			if(vo2==null) {
				gatherVO.setId(UUIDUtils.uuid());

				x+=gatherDao.create(gatherVO);
			} else {
				x+=gatherDao.updateSelective(gatherVO);
			}

		}
		return x;
	}

	public Map<String, Object> getJcjhMap(GatherQueryVO gatherQueryVO, Integer pageNum, Integer pageSize) {
		return null;
	}

	public GatherVO gatherInfo(GatherQueryVO gatherQueryVO) {
		return gatherDao.gatherInfo(gatherQueryVO);
	}

	public int updategatherInfo(List<String> dwids) {
		int x=0;
		for(String string:dwids) {
			if(CurrentUtil.getOrgId().length()==5) {
				x+=gatherDao.upgather(string.substring(0, 8));
			} else {
				x+=gatherDao.upgather(string);
			}
		}
		return x;
	}


}
