package com.unis.inspectionplan.server.domain;

import java.util.ArrayList;
import java.util.Calendar;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

import com.unis.inspectionplan.common.vo.*;
import com.unis.inspectionplan.server.dao.*;
import org.apache.commons.collections.CollectionUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.github.pagehelper.Page;
import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.common.utils.DateUtil;
import com.unis.common.utils.LsBeanUtils;
import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectionplan.server.entity.TBjdwlxDO;
import com.unis.inspectionplan.server.entity.TFileDO;
import com.unis.inspectionplan.server.entity.TJcbdDO;
import com.unis.inspectionplan.server.entity.TJcdwDO;
import com.unis.inspectionplan.server.entity.TJcjhDO;
import com.unis.inspectionplan.server.example.TJcdwExample;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

@Getter
@Setter
@ToString
@Component
public class InspectionplanDomain extends BaseDomain {

	@Autowired
	private TJcjhDao jcjhDao;

	@Autowired
	private TJcbdDao jcbdDao;

	@Autowired
	private TJcdwDao jcdwDao;

	@Autowired
	private TBjdwlxDao bjdwlxDao;

	@Autowired
	private FcbgzDao fcbgzDao;

	@Autowired
	private TFileDao fileDao;

	/**
	 * 新增检查计划
	 *
	 * @param jcjhVO
	 * @return
	 */
	public int insertJcjh(InspectionplanVO jcjhVO) {

		InspectionplanDomain inspectionplanDomain=new InspectionplanDomain();
		// 生成编号
		String jhId = "";
		if(jcjhVO.getRwlxId().equals("5000110")) {
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("RC" + DateUtil.getDate()),
					"RC" + DateUtil.getDate(), 3);
		} else if(jcjhVO.getRwlxId().equals("5000120")) {
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("FX" + DateUtil.getDate()),
					"FX" + DateUtil.getDate(), 3);
		}  else if(jcjhVO.getRwlxId().equals("5000130")) {
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("SF" + DateUtil.getDate()),
					"SF" + DateUtil.getDate(), 3);
		}  else if(jcjhVO.getRwlxId().equals("5000140")) {
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("ZX" + DateUtil.getDate()),
					"ZX" + DateUtil.getDate(), 3);
		}   else if(jcjhVO.getRwlxId().equals("5000150")) {
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("CBRC" + DateUtil.getDate()),
					"CBRC" + DateUtil.getDate(), 3);
		}  else if(jcjhVO.getRwlxId().equals("5000160")) {
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("ZX" + DateUtil.getDate()),
					"ZX" + DateUtil.getDate(), 3);
		}  else if(jcjhVO.getRwlxId().equals("5000170")) {//20200515,wys:市级储备粮检查
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("CBJC" + DateUtil.getDate()),
					"CBJC" + DateUtil.getDate(), 3);
		}  else if(jcjhVO.getRwlxId().equals("5000180")) {//20200515,wys:市级储备粮检查
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("AQ" + DateUtil.getDate()),
					"AQ" + DateUtil.getDate(), 3);
			if(jcjhVO.getRwjsr()==null) {
				jcjhVO.setRwjsr(getCurrYearLast());
			}
		}else {
			jhId=inspectionplanDomain.getMaxCodeById(jcjhDao.getMaxCodeById("SJ" + DateUtil.getDate()),
					"SJ" + DateUtil.getDate(), 3);
		}
		jcjhVO.setJhId(jhId);

		// 获得检查单位列表
		List<InspectionUnitVO> jcdwList = jcjhVO.getJcdwList();
		if (jcdwList != null) {
			for (InspectionUnitVO vo : jcdwList) {
				vo.setJhId(jhId);
				// 检查单位
				TJcdwDO jcdwDo = new TJcdwDO();
				LsBeanUtils.copyAllProperties(vo, jcdwDo);

				// 插入检查单位
				jcdwDao.insertSelective(jcdwDo);
			}
		}

		// 获得被检查单位列表
		List<TypesofInspectedUnitsVO> bjdwlxList = jcjhVO.getBjdwlxList();
		if (bjdwlxList != null) {
			for (TypesofInspectedUnitsVO vo : bjdwlxList) {
				vo.setJhId(jhId);
				// 插入被检查单位
				TBjdwlxDO bjdwlx = new TBjdwlxDO();
				LsBeanUtils.copyAllProperties(vo, bjdwlx);

				bjdwlxDao.insertSelective(bjdwlx);
			}
		}

		// 获得文件列表
		List<FileVO> file = jcjhVO.getFile();
		if (file != null) {

			for (FileVO vo : file) {
				vo.setSjId(jhId);
				// 插入文件
				TFileDO filedo = new TFileDO();
				LsBeanUtils.copyAllProperties(vo, filedo);

				fileDao.insertSelective(filedo);
			}

		}

		// 获得表单列表
		List<CheckformVO> jcbd = jcjhVO.getJcbd();
		if (jcbd != null) {
			for (CheckformVO tJcbdVO : jcbd) {
				tJcbdVO.setJhId(jhId);
				// 插入表单
				TJcbdDO jcbddo = new TJcbdDO();
				LsBeanUtils.copyAllProperties(tJcbdVO, jcbddo);
				/*long id = idWorker.nextId();
				jcbddo.setId(id);*/
				jcbdDao.insertSelective(jcbddo);
			}

		}

		// 检查计划VO转DO
		TJcjhDO jcjhDO = new TJcjhDO();
		LsBeanUtils.copyAllProperties(jcjhVO, jcjhDO);

		// 新增检查计划
		int insertSelective = jcjhDao.insertSelective(jcjhDO);

		if (insertSelective > 0) {
			return insertSelective;
		}

		return insertSelective;

	}

	/**
	 * 分页查询
	 *
	 * @return
	 */

	public Map<String, Object> getJcjhList(InspectionplanQueryVO queryvo,Integer pageNum,Integer pageSize) {
		//计划volist
		List<InspectionplanVO> InspectionplanVOlist = new ArrayList<InspectionplanVO>();

		//TJcjhDO分页
		PageHelper.startPage(pageNum, pageSize);
		//计划dolist
		List<TJcjhDO> dolist = jcjhDao.getList(queryvo);
		PageInfo<TJcjhDO> PageInfoDO = new PageInfo<TJcjhDO>(dolist);

		for (TJcjhDO tJcjhDO : dolist) {
		// 给计划VO添加表单list
			/*List<CheckformVO> CheckformVOList = new ArrayList<CheckformVO>();
			List<TJcbdDO> doList = jcbdDao.selectByJhid(tJcjhDO.getJhId());
			for (TJcbdDO tJcbdDO : doList) {
				CheckformVO checkformVO = new CheckformVO();
				LsBeanUtils.copyAllProperties(tJcbdDO, checkformVO);
				CheckformVOList.add(checkformVO);
			}*/
			// 给计划VO添加备件单位类型list
			/*List<TypesofInspectedUnitsVO> TypesofInspectedUnitsVOList = new ArrayList<TypesofInspectedUnitsVO>();
			List<TBjdwlxDO> doList2 = bjdwlxDao.selectByJhid(tJcjhDO.getJhId());
			for (TBjdwlxDO tBjdwlxDO : doList2) {
				TypesofInspectedUnitsVO typesofInspectedUnitsVO = new TypesofInspectedUnitsVO();
				LsBeanUtils.copyAllProperties(tBjdwlxDO, typesofInspectedUnitsVO);
				TypesofInspectedUnitsVOList.add(typesofInspectedUnitsVO);
			}*/
			// 给计划VO添加检查单位list
			List<InspectionUnitVO> InspectionUnitVOList = new ArrayList<InspectionUnitVO>();
			List<TJcdwDO> doList3 = jcdwDao.selectByJhId(tJcjhDO.getJhId());
			for (TJcdwDO tJcdwDO : doList3) {
				InspectionUnitVO inspectionUnitVO = new InspectionUnitVO();
				LsBeanUtils.copyAllProperties(tJcdwDO, inspectionUnitVO);
				InspectionUnitVOList.add(inspectionUnitVO);
			}
			// 给计划VO添加文件list
			/*List<FileVO> FileVOList = new ArrayList<FileVO>();
			List<TFileDO> doList4 = fileDao.selectBySjid(tJcjhDO.getJhId());
			for (TFileDO tFileDO : doList4) {
				FileVO fileVO = new FileVO();
				LsBeanUtils.copyAllProperties(tFileDO, fileVO);
				FileVOList.add(fileVO);
			}*/

			//计划vo
			InspectionplanVO vo = new InspectionplanVO();
			//vo.setJcbd(CheckformVOList);
			//vo.setBjdwlxList(TypesofInspectedUnitsVOList);
			vo.setJcdwList(InspectionUnitVOList);
			//vo.setFile(FileVOList);
			//计划do转vo
			LsBeanUtils.copyAllProperties(tJcjhDO, vo);

			//计划volist添加计划vo
			InspectionplanVOlist.add(vo);

		}


		//PageInfo<InspectionplanVO> PageInfoVO=new PageInfo<InspectionplanVO>(InspectionplanVOlist);



		//----------------------
		 Map<String, Object> hashMap = new HashMap<String,Object>();
		 hashMap.put("total",PageInfoDO.getTotal());
		 hashMap.put("InspectionplanVOlist",InspectionplanVOlist);


		return hashMap;

	}

	/**
	 * 查看检查计划
	 *
	 * @param jhId
	 * @return
	 */
	public InspectionplanVO getInspectionlan(String jhId) {

		TJcjhDO jcjhDO = jcjhDao.selectByPrimaryKey(jhId);

		if (jcjhDO == null) {
			return null;
		}
		// 获取检查表单列表
		List<CheckformVO> voList = new ArrayList<CheckformVO>();
		List<TJcbdDO> doList = jcbdDao.selectByJhid(jcjhDO.getJhId());
		for (TJcbdDO tJcbdDO : doList) {
			CheckformVO vo = new CheckformVO();
			LsBeanUtils.copyAllProperties(tJcbdDO, vo);
			voList.add(vo);
		}

		// 获取被检企业类型列表
		List<TypesofInspectedUnitsVO> voList2 = new ArrayList<TypesofInspectedUnitsVO>();
		List<TBjdwlxDO> doList2 = bjdwlxDao.selectByJhid(jcjhDO.getJhId());
		for (TBjdwlxDO tBjdwlxDO : doList2) {
			TypesofInspectedUnitsVO vo = new TypesofInspectedUnitsVO();
			LsBeanUtils.copyAllProperties(tBjdwlxDO, vo);
			voList2.add(vo);
		}

		// 获取检查单位列表
		List<InspectionUnitVO> voList3 = new ArrayList<InspectionUnitVO>();
		List<TJcdwDO> doList3 = jcdwDao.selectByJhId(jcjhDO.getJhId());
		for (TJcdwDO tJcdwDO : doList3) {
			InspectionUnitVO vo = new InspectionUnitVO();
			LsBeanUtils.copyAllProperties(tJcdwDO, vo);
			voList3.add(vo);
		}

		// 获取检查文件列表
		List<FileVO> voList4 = new ArrayList<FileVO>();
		List<TFileDO> doList4 = fileDao.selectBySjid(jcjhDO.getJhId());
		for (TFileDO tFileDO : doList4) {
			FileVO vo = new FileVO();
			LsBeanUtils.copyAllProperties(tFileDO, vo);
			voList4.add(vo);
		}

		// DO转VO
		InspectionplanVO vo = new InspectionplanVO();
		vo.setJcbd(voList);
		vo.setBjdwlxList(voList2);
		vo.setJcdwList(voList3);
		vo.setFile(voList4);
		LsBeanUtils.copyAllProperties(jcjhDO, vo);

		return vo;

	}

	/**
	 * 编辑检查计划
	 *
	 * @return
	 */
	public int updateInspectionlan(InspectionplanVO jcjhvo) {

		// 得到计划id
		String jhId = jcjhvo.getJhId();

		TJcjhDO jcjhDO = jcjhDao.selectByPrimaryKey(jhId);

		// 更改TJcbd原来数据库的status
		List<TJcbdDO> doList = jcbdDao.selectByJhid(jcjhDO.getJhId());
		if(doList != null){
			for (TJcbdDO tJcbdDO : doList) {
				tJcbdDO.setStatus(0);
				jcbdDao.updateByPrimaryKeySelective(tJcbdDO);
			}
		}
		// 新增TJcbdDO
		List<CheckformVO> voList = jcjhvo.getJcbd();
		if(voList != null){
			for (CheckformVO checkformVO : voList) {
				TJcbdDO tJcbdDO = new TJcbdDO();
				checkformVO.setJhId(jhId);
				checkformVO.setStatus(1);
				LsBeanUtils.copyAllProperties(checkformVO, tJcbdDO);
				jcbdDao.insertSelective(tJcbdDO);
			}
		}

		// 更改TBjdwlx原来数据库的status
		List<TBjdwlxDO> doList2 = bjdwlxDao.selectByJhid(jcjhDO.getJhId());
		if(doList2 != null){
			for (TBjdwlxDO tBjdwlxDO : doList2) {
				tBjdwlxDO.setStatus(0);
				bjdwlxDao.updateByPrimaryKeySelective(tBjdwlxDO);
			}
		}
		// 新增TJcbdDO
		List<TypesofInspectedUnitsVO> voList2 = jcjhvo.getBjdwlxList();
		if(voList2 != null){
			for (TypesofInspectedUnitsVO typesofInspectedUnitsVO : voList2) {
				TBjdwlxDO tBjdwlxDO = new TBjdwlxDO();
				typesofInspectedUnitsVO.setJhId(jhId);
				typesofInspectedUnitsVO.setStatus(1);
				LsBeanUtils.copyAllProperties(typesofInspectedUnitsVO, tBjdwlxDO);
				bjdwlxDao.insertSelective(tBjdwlxDO);
			}
		}

		// 更改TJcdw原来数据库的status
		List<TJcdwDO> doList3 = jcdwDao.selectByJhId(jcjhDO.getJhId());
		if(doList3 != null){
			for (TJcdwDO tJcdwDO : doList3) {
				tJcdwDO.setStatus(0);
				jcdwDao.updateByPrimaryKeySelective(tJcdwDO);
			}
		}
		// 新增TJcdwDO
		List<InspectionUnitVO> voList3 = jcjhvo.getJcdwList();
		if(voList3 != null){
			for (InspectionUnitVO inspectionUnitVO : voList3) {
				TJcdwDO tJcdwDO = new TJcdwDO();
				inspectionUnitVO.setJhId(jhId);
				inspectionUnitVO.setStatus(1);
				LsBeanUtils.copyAllProperties(inspectionUnitVO, tJcdwDO);
				jcdwDao.insertSelective(tJcdwDO);
			}
		}

		// 更改TFile原来数据库的status
		List<TFileDO> doList4 = fileDao.selectBySjid(jcjhDO.getJhId());
		if(doList4 != null){
			for (TFileDO tFileDO : doList4) {
				tFileDO.setStatus(0);
				fileDao.updateByPrimaryKeySelective(tFileDO);
			}
		}
		// 新增TFileDO
		List<FileVO> voList4 = jcjhvo.getFile();
		if(voList4 != null){
			for (FileVO fileVO : voList4) {
				TFileDO tFileDO = new TFileDO();
				fileVO.setSjId(jhId);
				fileVO.setStatus(1);
				LsBeanUtils.copyAllProperties(fileVO, tFileDO);
				fileDao.insertSelective(tFileDO);
			}
		}

		LsBeanUtils.copyAllProperties(jcjhvo, jcjhDO);
		int updateByPrimaryKeySelective = jcjhDao.updateByPrimaryKeySelective(jcjhDO);

		if(updateByPrimaryKeySelective>0){

			return updateByPrimaryKeySelective;
		}

		return 0;
	}

	/**
	 * 只更新计划状态
	 * @param jcjhvo
	 * @return
	 */
	public int updateInspectionlanonly(InspectionplanVO jcjhvo){

	    if ("3".equals(jcjhvo.getJhzt().toString()) || "5".equals(jcjhvo.getJhzt().toString()) || "4".equals(jcjhvo.getJhzt().toString())) {
	    	jcjhvo.setJhzt(jcjhvo.getJhzt());
		} else {
			jcjhvo.setJhzt(2);
		}

		TJcjhDO jcjhDO = new TJcjhDO();
		LsBeanUtils.copyAllProperties(jcjhvo, jcjhDO);
		return jcjhDao.updateByPrimaryKeySelective(jcjhDO);
	}

	/**
	 * 撤回计划
	 *
	 * @return
	 */
	public int deleteInspectionlan( String jhId) {
		// 更新计划
		TJcjhDO entity = jcjhDao.selectByPrimaryKey(jhId);
		//（1、待下发。2、一下发。3、已完成。4、已过期）
		entity.setJhzt(1);
		entity.setXfsj(null);
		entity.setXfr(null);
		int updateByPrimaryKey = jcjhDao.updateByPrimaryKeySelective(entity);
		return updateByPrimaryKey;
	}


	/**
	 * 删除计划
	 * @param jcjhvo
	 * @return
	 */
	public ResponseWrapper deleteById(InspectionplanVO jcjhvo){
		// 更新计划
		TJcjhDO entity = jcjhDao.selectByPrimaryKey(jcjhvo.getJhId());
		if(entity!=null){
			if(entity.getJhzt()==1){
//				TJcdwExample example=new TJcdwExample();
//				example.createCriteria().andJhIdEqualTo(jcjhvo.getJhId());
//				jcdwDao.deleteByExample(example);
//				jcjhDao.deleteByPrimaryKey(jcjhvo.getJhId());
				jcjhDao.updateById(jcjhvo.getJhId());
				return ResponseWrapper.success();
			}else{
				return ResponseWrapper.error("当前不可删除");
			}
		}else{
			return ResponseWrapper.notFound();
		}
	}



	public List<InspectionplanVO> getJcjhList(String rwlxbh) {
		//计划volist
				List<InspectionplanVO> InspectionplanVOlist = new ArrayList<InspectionplanVO>();

		//计划dolist
		List<TJcjhDO> dolist = jcjhDao.getJcjhList(rwlxbh);


		for (TJcjhDO tJcjhDO : dolist) {

		// 给计划VO添加表单list
			List<CheckformVO> CheckformVOList = new ArrayList<CheckformVO>();
			List<TJcbdDO> doList = jcbdDao.selectByJhid(tJcjhDO.getJhId());
			for (TJcbdDO tJcbdDO : doList) {
				CheckformVO checkformVO = new CheckformVO();
				LsBeanUtils.copyAllProperties(tJcbdDO, checkformVO);
				CheckformVOList.add(checkformVO);
			}
			// 给计划VO添加备件单位类型list
			List<TypesofInspectedUnitsVO> TypesofInspectedUnitsVOList = new ArrayList<TypesofInspectedUnitsVO>();
			List<TBjdwlxDO> doList2 = bjdwlxDao.selectByJhid(tJcjhDO.getJhId());
			for (TBjdwlxDO tBjdwlxDO : doList2) {
				TypesofInspectedUnitsVO typesofInspectedUnitsVO = new TypesofInspectedUnitsVO();
				LsBeanUtils.copyAllProperties(tBjdwlxDO, typesofInspectedUnitsVO);
				TypesofInspectedUnitsVOList.add(typesofInspectedUnitsVO);
			}
			// 给计划VO添加检查单位list
			List<InspectionUnitVO> InspectionUnitVOList = new ArrayList<InspectionUnitVO>();
			List<TJcdwDO> doList3 = jcdwDao.selectByJhId(tJcjhDO.getJhId());
			for (TJcdwDO tJcdwDO : doList3) {
				InspectionUnitVO inspectionUnitVO = new InspectionUnitVO();
				LsBeanUtils.copyAllProperties(tJcdwDO, inspectionUnitVO);
				InspectionUnitVOList.add(inspectionUnitVO);
			}
			// 给计划VO添加文件list
			List<FileVO> FileVOList = new ArrayList<FileVO>();
			List<TFileDO> doList4 = fileDao.selectBySjid(tJcjhDO.getJhId());
			for (TFileDO tFileDO : doList4) {
				FileVO fileVO = new FileVO();
				LsBeanUtils.copyAllProperties(tFileDO, fileVO);
				FileVOList.add(fileVO);
			}

			//计划vo
			InspectionplanVO vo = new InspectionplanVO();
			vo.setJcbd(CheckformVOList);
			vo.setBjdwlxList(TypesofInspectedUnitsVOList);
			vo.setJcdwList(InspectionUnitVOList);
			vo.setFile(FileVOList);
			//计划do转vo
			LsBeanUtils.copyAllProperties(tJcjhDO, vo);

			// 安全检查特别处理，返回rwId 用于结果检查更新
			if(("5000180").equals(tJcjhDO.getRwlxId())) {
				String rwId = jcdwDao.selectRwIdyJhId(tJcjhDO.getJhId());
				vo.setRwId(rwId);
			}

			//计划volist添加计划vo
			InspectionplanVOlist.add(vo);

		}
		return InspectionplanVOlist;
	}

	public Map<String, Object> getplaceList(InspectionplanQueryVO queryvo, Integer pageNum, Integer pageSize) {
		//计划volist
		List<InspectionplanVO> InspectionplanVOlist = new ArrayList<InspectionplanVO>();

		//TJcjhDO分页
		PageHelper.startPage(pageNum, pageSize);
		//计划dolist
		List<TJcjhDO> dolist = jcjhDao.getplaceList(queryvo);

		PageInfo<TJcjhDO> PageInfoDO = new PageInfo<TJcjhDO>(dolist);

		for (TJcjhDO tJcjhDO : dolist) {

		// 给计划VO添加表单list
			List<CheckformVO> CheckformVOList = new ArrayList<CheckformVO>();
			List<TJcbdDO> doList = jcbdDao.selectByJhid(tJcjhDO.getJhId());
			for (TJcbdDO tJcbdDO : doList) {
				CheckformVO checkformVO = new CheckformVO();
				LsBeanUtils.copyAllProperties(tJcbdDO, checkformVO);
				CheckformVOList.add(checkformVO);
			}
			// 给计划VO添加备件单位类型list
			List<TypesofInspectedUnitsVO> TypesofInspectedUnitsVOList = new ArrayList<TypesofInspectedUnitsVO>();
			List<TBjdwlxDO> doList2 = bjdwlxDao.selectByJhid(tJcjhDO.getJhId());
			for (TBjdwlxDO tBjdwlxDO : doList2) {
				TypesofInspectedUnitsVO typesofInspectedUnitsVO = new TypesofInspectedUnitsVO();
				LsBeanUtils.copyAllProperties(tBjdwlxDO, typesofInspectedUnitsVO);
				TypesofInspectedUnitsVOList.add(typesofInspectedUnitsVO);
			}
			// 给计划VO添加检查单位list
			List<InspectionUnitVO> InspectionUnitVOList = new ArrayList<InspectionUnitVO>();
			List<TJcdwDO> doList3 = jcdwDao.selectByJhId(tJcjhDO.getJhId());
			for (TJcdwDO tJcdwDO : doList3) {
				InspectionUnitVO inspectionUnitVO = new InspectionUnitVO();
				LsBeanUtils.copyAllProperties(tJcdwDO, inspectionUnitVO);
				InspectionUnitVOList.add(inspectionUnitVO);
			}
			// 给计划VO添加文件list
			List<FileVO> FileVOList = new ArrayList<FileVO>();
			List<TFileDO> doList4 = fileDao.selectBySjid(tJcjhDO.getJhId());
			for (TFileDO tFileDO : doList4) {
				FileVO fileVO = new FileVO();
				LsBeanUtils.copyAllProperties(tFileDO, fileVO);
				FileVOList.add(fileVO);
			}

			//计划vo
			InspectionplanVO vo = new InspectionplanVO();
			vo.setJcbd(CheckformVOList);
			vo.setBjdwlxList(TypesofInspectedUnitsVOList);
			vo.setJcdwList(InspectionUnitVOList);
			vo.setFile(FileVOList);
			//计划do转vo
			LsBeanUtils.copyAllProperties(tJcjhDO, vo);

			//计划volist添加计划vo
			InspectionplanVOlist.add(vo);

		}


		//PageInfo<InspectionplanVO> PageInfoVO=new PageInfo<InspectionplanVO>(InspectionplanVOlist);



		//----------------------
		 Map<String, Object> hashMap = new HashMap<String,Object>();
		 hashMap.put("total",PageInfoDO.getTotal());
		 hashMap.put("InspectionplanVOlist",InspectionplanVOlist);


		return hashMap;
	}

	/**
	 * @param jhId
	 * @return 归档
	 */
	public int update(String jhId) {
		return jcjhDao.update(jhId);
	}

	/**
	 * @Title: inspectionplanMain
	 * @Description:方法描述:(这里用一句话描述这个方法的作用)
	 * @param @param inspectionplanQueryVo
	 * @param @return    设定文件
	 * @return List<InspectionplanVO>    返回类型
	 * @throws
	*/
	public List<InspectionplanVO> inspectionplanMain(InspectionplanQueryVO inspectionplanQueryVo) {
		inspectionplanQueryVo.setJhzt(2);
		TJcjhDO tJcjhDO=new TJcjhDO();
		LsBeanUtils.copyAllProperties(inspectionplanQueryVo, tJcjhDO);
		List<TJcjhDO> tJcjhDOs = jcjhDao.getPlanList(tJcjhDO);
		if(tJcjhDOs==null) {
			return null;
		}
		List<InspectionplanVO> inspectionplanVOs = new ArrayList<InspectionplanVO>();
		LsBeanUtils.copyCollection(tJcjhDOs, inspectionplanVOs, InspectionplanVO.class);
	    return inspectionplanVOs;
	}

	/**
	 *
	 * @Description: 分页查询某状态计划列表
	 * @author: 王帅
	 * @param: @param  pageSize
	 * @param: @param  pageNum
	 * @param: @return 参数
	 * @return: List<InspectionplanVO> 返回类型
	 */
	public List<InspectionplanVO> planUnfinishedList(int pageSize, int pageNum, Integer status) {
		TJcjhDO entity = new TJcjhDO();
		entity.setJhzt(status);
		PageHelper.startPage(pageNum, pageSize);
		List<TJcjhDO> page = (Page<TJcjhDO>) jcjhDao.getPlanList(entity);
		if (CollectionUtils.isEmpty(page)) {
			return null;
		}
		List<InspectionplanVO> showVOList = new ArrayList<InspectionplanVO>();
		LsBeanUtils.copyCollection(page, showVOList, InspectionplanVO.class);

		return showVOList;
	}

	/**
	 *
	 * @Description: 获取某状态下计划总数
	 * @author: 王帅
	 * @param: @param  status
	 * @param: @return 参数
	 * @return: Long 返回类型
	 */
	public Long getPlanUnfinishedCount(Integer status) {
		return jcjhDao.getPlanUnfinishedCount(status);
	}

	/**
     * 获取当年的最后一天
     * @param year
     * @return
     */
    public static Date getCurrYearLast(){
        Calendar currCal=Calendar.getInstance();
        int currentYear = currCal.get(Calendar.YEAR);
        return getYearLast(currentYear);
    }

    /**
     * 获取某年最后一天日期
     * @param year 年份
     * @return Date
     */
    public static Date getYearLast(int year){
        Calendar calendar = Calendar.getInstance();
        calendar.clear();
        calendar.set(Calendar.YEAR, year);
        calendar.roll(Calendar.DAY_OF_YEAR, -1);
        Date currYearLast = calendar.getTime();

        return currYearLast;
    }

	public int backlog(String id) {
		return jcjhDao.backlog(id);
	}

	public List<StockVO> getStockInfoByCh(String cfbm) {
		List<StockVO> voList = fcbgzDao.selectByCh(cfbm);
		String ch = voList.get(0).getHouseId();
		List<StockVO>stockVOList = fcbgzDao.selectByCH1(ch);
		for (StockVO vo : voList) {
			for (StockVO stockVO : stockVOList) {
				if (vo.getWarehouseId().equals(stockVO.getWarehouseId())){
					vo.setPinp(stockVO.getPinp());
					vo.setBzq(stockVO.getBzq());
					vo.setScrq(stockVO.getScrq());
					vo.setStartTime(stockVO.getStartTime());
				}
			}
		}
		return voList;
	}
}
