package com.unis.inspectionplan.server.domain;

import java.util.ArrayList;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import java.util.UUID;

import org.apache.commons.lang3.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Component;

import com.github.pagehelper.PageHelper;
import com.github.pagehelper.PageInfo;
import com.unis.common.utils.CurrentUtil;
import com.unis.inspectionplan.common.vo.CheckformVO;
import com.unis.inspectionplan.common.vo.InspectionUnitVO;
import com.unis.inspectionplan.common.vo.InspectionplanVO;
import com.unis.inspectionplan.common.vo.YearPlanChartDVO;
import com.unis.inspectionplan.common.vo.YearPlanChartVO;
import com.unis.inspectionplan.common.vo.YearPlanOrgVO;
import com.unis.inspectionplan.common.vo.YearPlanVO;
import com.unis.inspectionplan.server.dao.YearPlanDao;
import com.unis.inspectionplan.server.entity.TJcjhDO;

import lombok.Getter;
import lombok.Setter;
import lombok.ToString;

@Getter
@Setter
@ToString
@Component
public class YearPlanDomain {

	@Autowired
	private YearPlanDao yearPlanDao;

	public int yearplan(YearPlanVO yearPlanVO) {
		String yearid = UUID.randomUUID().toString();
		yearPlanVO.setId(yearid);
		yearPlanVO.setOrgid(CurrentUtil.getOrgId());
		int i = yearPlanDao.create(yearPlanVO);
		if(i>0&&yearPlanVO.getJcdwList()!=null&&yearPlanVO.getJcdwList().size()>0) {
			for(YearPlanOrgVO planOrgVO : yearPlanVO.getJcdwList()) {
				planOrgVO.setNdjhid(yearid);
				planOrgVO.setId(UUID.randomUUID().toString());
				yearPlanDao.insertYearOrg(planOrgVO);
			}
		}
		//生成任务
		if(StringUtils.isNoneEmpty(yearPlanVO.getStatus())&&yearPlanVO.getStatus().equals("1")) {
			create(yearPlanVO);
		}
		return i;
	}


	@Autowired
	private InspectionplanDomain inspectionplanDomain;

	private void create(YearPlanVO yearPlanVO) {
		InspectionplanVO inspectionplanVO = new InspectionplanVO();
		List<InspectionUnitVO> inspectionUnitVOs = new ArrayList<InspectionUnitVO>();
		List<CheckformVO> checkformVOs = new ArrayList<CheckformVO>();
		inspectionplanVO.setJhName(yearPlanVO.getJhmc());
		inspectionplanVO.setRwqsr(yearPlanVO.getJhkssj());
		inspectionplanVO.setRwjsr(yearPlanVO.getJhjssj());
		inspectionplanVO.setCreateDate(new Date());
		inspectionplanVO.setXfr(yearPlanVO.getZdr());
		inspectionplanVO.setStatus(1);
		inspectionplanVO.setIsBjjcz(1);
		inspectionplanVO.setPlanid(yearPlanVO.getId());
		if(StringUtils.isNotEmpty(yearPlanVO.getOrgid())) {
			inspectionplanVO.setOrgId(yearPlanVO.getOrgid());
		} else {
			inspectionplanVO.setOrgId("LS001");
		}

		inspectionplanVO.setXfsj(new Date());
		inspectionplanVO.setRwlxId("5000110");
		inspectionplanVO.setRwlxmc("日常检查");
		inspectionplanVO.setJhzt(1);
		CheckformVO checkformVO = new CheckformVO();
		checkformVO.setBdId("BD20190822006");
		checkformVO.setBdName("现场检查记录表");
		checkformVO.setBdLu("/inspection/sceneCheckRecord");
		checkformVO.setStatus(1);
		checkformVOs.add(checkformVO);
		inspectionplanVO.setJcbd(checkformVOs);
		for(YearPlanOrgVO orgVO:yearPlanVO.getJcdwList()) {
			InspectionUnitVO inspectionUnitVO = new InspectionUnitVO();
			inspectionUnitVO.setJcdwId(orgVO.getJcdwid());
			inspectionUnitVO.setStatus(1);
			inspectionUnitVO.setJcdwName(orgVO.getJcdwmc());
			inspectionUnitVOs.add(inspectionUnitVO);
		}
		inspectionplanVO.setJcdwList(inspectionUnitVOs);
		inspectionplanDomain.insertJcjh(inspectionplanVO);
	}

	public String updateyearplan(YearPlanVO yearPlanVO) {
		yearPlanVO.setOrgid(CurrentUtil.getOrgId());

		//撤回任务
		if(StringUtils.isNoneEmpty(yearPlanVO.getStatus())&&yearPlanVO.getStatus().equals("2")) {
			List<String> list = yearPlanDao.getJgList(yearPlanVO.getId());
			for(String string:list) {
				if(string.equals("0")||string.equals("2")) {
					return "下发任务已执行，无法撤回！";//已有下发
				}
			}
			//执行删除结果
			yearPlanDao.updateJg(yearPlanVO.getId());
			//执行删除任务
			yearPlanDao.updateRw(yearPlanVO.getId());
			//执行删除计划
			yearPlanDao.updateJh(yearPlanVO.getId());
			yearPlanDao.updateSelective(yearPlanVO);
			return "撤回成功";//撤回成功
		} else if(StringUtils.isNoneEmpty(yearPlanVO.getStatus())&&yearPlanVO.getStatus().equals("1")) {
			int i = yearPlanDao.updateSelective(yearPlanVO);
			create(yearPlanVO);
			return "生成成功";//下发成功
		} else {
			int i = yearPlanDao.updateSelective(yearPlanVO);
			yearPlanDao.deleteYearOrg(yearPlanVO.getId());
			if(i>0&&yearPlanVO.getJcdwList()!=null&&yearPlanVO.getJcdwList().size()>0) {
				for(YearPlanOrgVO planOrgVO : yearPlanVO.getJcdwList()) {
					planOrgVO.setNdjhid(yearPlanVO.getId());
					planOrgVO.setId(UUID.randomUUID().toString());
					yearPlanDao.insertYearOrg(planOrgVO);
				}
			}
			return "修改成功";//更新成功
		}
	}


	public Map<String, Object> getJcjhList(String jcnd,String jhmc, Integer pageNum, Integer pageSize) {
		PageHelper.startPage(pageNum, pageSize);
		List<YearPlanVO> yearPlanVOs = yearPlanDao.selectYearPaln(jcnd,jhmc,CurrentUtil.getOrgId());
		PageInfo<YearPlanVO> PageInfoDO = new PageInfo<YearPlanVO>(yearPlanVOs);
		for(YearPlanVO planVO:PageInfoDO.getList()) {
			List<YearPlanOrgVO> planOrgVOs = yearPlanDao.selectYearOrgPaln(planVO.getId());
			planVO.setJcdwList(planOrgVOs);
		}

		Map<String, Object> hashMap = new HashMap<String,Object>();
		 hashMap.put("total",PageInfoDO.getTotal());
		 hashMap.put("yearPlanlist",yearPlanVOs);
		return hashMap;
	}

	public List<YearPlanChartVO> getInspectionplanList(String jhnf,String jhmc) {
		List<YearPlanChartVO> yearPlanChartVOs = yearPlanDao.getYearPlan(jhnf,jhmc,CurrentUtil.getOrgId());
		for(YearPlanChartVO planChartVO:yearPlanChartVOs) {
			List<YearPlanChartDVO> planChartDVOs = yearPlanDao.getYearPlanD(planChartVO.getJhmc());
			planChartVO.setPlanChartDVOs(planChartDVOs);
		}
		return yearPlanChartVOs;
	}

	public List<YearPlanVO> getndTodoList() {
		List<YearPlanVO> planVOs = yearPlanDao.getndTodoList();
		for(YearPlanVO planVO:planVOs) {
			List<YearPlanOrgVO> planOrgVOs = yearPlanDao.selectYearOrgPaln(planVO.getId());
			planVO.setJcdwList(planOrgVOs);
		}
		return planVOs;
	}

	public void updateStatus(String id) {
		yearPlanDao.updateStatus(id);
	}

	public String delete(String id) {
		yearPlanDao.delete(id);
		return "删除成功";
	}

}
