package com.unis.inspectionplan.server.entity;
import java.io.Serializable;
import java.util.Date;

import javax.persistence.Column;
import javax.persistence.MappedSuperclass;

import lombok.Getter;
import lombok.Setter;


/**
 * 基础实体类
 * 所有继承该实体类的实体在映射成表的时候会自动加入该类中的字段
 *
 * @author huangxing
 */
@Getter
@Setter
@MappedSuperclass
public abstract class BaseEntity implements Serializable {

	private static final long serialVersionUID = 1L;

	/**
     * 状态默认为1
     */
    @Column(name="status")
    private int status = 1;
    
    /**
     * 创建人
     */
    @Column(name="createor")
    private String createor;
    
    /**
     * 创建人编号
     */
    @Column(name="createor_code")
    private String createorCode;

    /**
     * 创建时间
     */
    @Column(name="create_date")
    private Date createDate;

    /**
     * 刷新时间
     */
    @Column(name="refresh_time")
    private Date refreshTime;
    
    /**
     * 刷新人
     */
    @Column(name="refresher")
    private String refresher;
    
    /**
     * 刷新时间
     */
    @Column(name="refresh_date")
    private Date refreshDate;
    
    /**
     * 刷新人编号
     */
    @Column(name="refresher_code")
    private String refresherCode;

    /**
     * 备注
     */
    @Column(name="remark")
    private String remark;
}
