package com.unis.inspectionplan.server.service;

import java.util.List;
import java.util.Map;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectionplan.common.vo.StockVO;
import org.springframework.web.bind.annotation.PathVariable;
import org.springframework.web.bind.annotation.RequestParam;

import com.github.pagehelper.PageInfo;
import com.unis.inspectionplan.common.vo.InspectionplanQueryVO;
import com.unis.inspectionplan.common.vo.InspectionplanVO;


public interface InspectionplanService {

	/**
	 * 新增检查计划
	 * @return
	 */
	int insertJcjh(InspectionplanVO jcjhVO);

	/**
	 * 编辑检查计划
	 * @param jhId
	 * @return
	 */
	int updateJcjh(InspectionplanVO jcjhvo);


	/**
	 * 只更新计划状态
	 * @param jcjhvo
	 * @return
	 */
	public int updateInspectionlanonly(InspectionplanVO jcjhvo);


	/**
	 * 查看检查计划
	 * @param jhId
	 * @return
	 */
	InspectionplanVO getJcjh(String jhId);

	/**
	 * 获得检查计划列表
	 * @return
	 */
	Map<String, Object> getJcjhMap(InspectionplanQueryVO queryVO,Integer pageNum,Integer pageSize);


	/**
	 * 撤回计划
	 * @param jhId
	 * @return
	 */
	int deleteInspectionlan( String jhId);

	/**
	 * 删除计划
	 * @param jcjhvo
	 * @return
	 */
	public ResponseWrapper deleteById(InspectionplanVO jcjhvo);

	/**
	 * @param rwlxbh
	 * @return 根据任务类型编号获取任务列表
	 */
	List<InspectionplanVO> getInspectionplanList(String rwlxbh);

	Map<String, Object> getplaceList(InspectionplanQueryVO queryvo, Integer pageNum, Integer pageSize);

	int inspectionplanplace(String jhId);

	/**
	 * @Title: inspectionplanMain
	 * @Description:方法描述:(这里用一句话描述这个方法的作用)
	 * @param @param inspectionplanQueryVo
	 * @param @return    设定文件
	 * @return List<InspectionplanVO>    返回类型
	 * @throws
	*/
	List<InspectionplanVO> inspectionplanMain(InspectionplanQueryVO inspectionplanQueryVo);


	/**
	 *
	 * @Description: 分页查询某状态计划列表
	 * @author: 王帅
	 * @param: @param  pageSize
	 * @param: @param  pageNum
	 * @param: @return 参数
	 * @return: List<InspectionplanVO> 返回类型
	 */
	public List<InspectionplanVO> planUnfinishedList(int pageSize, int pageNum, Integer status);

	/**
	 *
	 * @Description: 获取某状态下计划总数
	 * @author: 王帅
	 * @param: @param  status
	 * @param: @return 参数
	 * @return: Long 返回类型
	 */
	public Long getPlanUnfinishedCount(Integer status);

	int backlog(String id);

	List<StockVO> getStockInfoByCh(String cfbm);
}
