package com.unis.inspectionplan.server.service.impl;

import java.util.List;
import java.util.Map;

import com.unis.inspectionplan.common.vo.StockVO;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.unis.common.utils.ResponseWrapper;
import com.unis.inspectionplan.common.vo.InspectionplanQueryVO;
import com.unis.inspectionplan.common.vo.InspectionplanVO;
import com.unis.inspectionplan.server.domain.InspectionplanDomain;
import com.unis.inspectionplan.server.service.InspectionplanService;

/**
 *
 * @author liuweilong
 *
 */
@Service
public class InspectionplanImpl implements InspectionplanService {

	@Autowired
	private InspectionplanDomain jcjhDomain;

	/**
	 * 新增检查计划
	 */
	@Override
	public int insertJcjh(InspectionplanVO jcjhVO) {

		return jcjhDomain.insertJcjh(jcjhVO);

	}

	/**
	 * 编辑检查计划
	 */
	@Override
	public int updateJcjh(InspectionplanVO jcjhvo) {

		int updateInspectionlan = jcjhDomain.updateInspectionlan(jcjhvo);

		return updateInspectionlan;
	}


	/**
	 * 只更新计划状态
	 * @param jcjhvo
	 * @return
	 */
	@Override
	public int updateInspectionlanonly(InspectionplanVO jcjhvo) {
		return jcjhDomain.updateInspectionlanonly(jcjhvo);
	}


	/**
	 * 查看检查计划
	 */
	@Override
	public InspectionplanVO getJcjh(String jhId) {

		InspectionplanVO inspectionlan = jcjhDomain.getInspectionlan(jhId);

		return inspectionlan;
	}

	/**
	 * 获得检查计划列表
	 */
	@Override
	public Map<String, Object> getJcjhMap(InspectionplanQueryVO queryvo, Integer pageNum,Integer pageSize) {

		Map<String, Object> jcjhmap = jcjhDomain.getJcjhList(queryvo, pageNum, pageSize);

		return jcjhmap;
	}



	/**
	 * 撤回计划
	 */
	@Override
	public int deleteInspectionlan( String jhId) {

		int deleteInspectionlan = jcjhDomain.deleteInspectionlan(jhId);

		return deleteInspectionlan;
	}

	/**
	 * 删除计划
	 * @param jcjhvo
	 * @return
	 */
	public ResponseWrapper deleteById(InspectionplanVO jcjhvo){
		return jcjhDomain.deleteById(jcjhvo);
	}

	@Override
	public List<InspectionplanVO> getInspectionplanList(String rwlxbh) {
		return jcjhDomain.getJcjhList(rwlxbh);
	}

	@Override
	public Map<String, Object> getplaceList(InspectionplanQueryVO queryvo, Integer pageNum, Integer pageSize) {
		Map<String, Object> jcjhmap = jcjhDomain.getplaceList(queryvo, pageNum, pageSize);

		return jcjhmap;
	}

	@Override
	public int inspectionplanplace(String jhId) {
		return jcjhDomain.update(jhId);
	}

	/** (非 Javadoc)
	* <p>Title: inspectionplanMain</p>
	* <p>Description: </p>
	* @param inspectionplanQueryVo
	* @return
	* @see com.unis.inspectionplan.server.service.InspectionplanService#inspectionplanMain(com.unis.inspectionplan.common.vo.InspectionplanQueryVO)
	*/
	@Override
	public List<InspectionplanVO> inspectionplanMain(InspectionplanQueryVO inspectionplanQueryVo) {
		return jcjhDomain.inspectionplanMain(inspectionplanQueryVo);
	}

	@Override
	public List<InspectionplanVO> planUnfinishedList(int pageSize, int pageNum, Integer status) {
		return jcjhDomain.planUnfinishedList(pageSize, pageNum, status);
	}

	@Override
	public Long getPlanUnfinishedCount(Integer status) {
		return jcjhDomain.getPlanUnfinishedCount(status);
	}

	@Override
	public int backlog(String id) {
		return jcjhDomain.backlog(id);
	}

	@Override
	public List<StockVO> getStockInfoByCh(String cfbm) {
		return jcjhDomain.getStockInfoByCh(cfbm);
	}

}
